;***************************************
;Tooltip code based on code by: T. Gowshall <trubbleguy@optusnet.com.au>
;AddGraphicButton code by : lingoist 
;***************************************


Run, C:\Program Files\REAPER\reaper.exe
#NoEnv 
#SingleInstance,Force

Gosub buttoninfo ;get the tooltip info for the mouseover
; Create the buttons  
Gui, +AlwaysOnTop -SysMenu +Owner

AddGraphicButton("Freeze", A_WorkingDir . "\freeze.ico", "x1 y1 h24 w24 gFreeze", 24, 24)
AddGraphicButton("UnFreeze", A_WorkingDir . "\unfreeze.ico", "x25 y1 h24 w24 gUnFreeze", 24, 24) 
AddGraphicButton("Marker", A_WorkingDir . "\marker.ico", "x50 y1 h24 w24 gMarker", 24, 24) 
AddGraphicButton("Mute", A_WorkingDir . "\mute.ico", "x75 y0 h24 w24 gMute", 24, 24) 
AddGraphicButton("NewTrack", A_WorkingDir . "\newtrack.ico", "x100 y1 h24 w24 gNewTrack", 24, 24) 
AddGraphicButton("ItemProps", A_WorkingDir . "\itemprops.ico", "x125 y1 h24 w24 gItemProps", 24, 24) 
AddGraphicButton("TimeSig", A_WorkingDir . "\timesig.ico", "x150 y1 h24 w24 gTimeSig", 24, 24) 
AddGraphicButton("Render", A_WorkingDir . "\render.ico", "x175 y1 h24 w24 gRender", 24, 24) 
AddGraphicButton("Clean", A_WorkingDir . "\clean.ico", "x200 y1 h24 w24 gClean", 24, 24) 
AddGraphicButton("Glue", A_WorkingDir . "\glue.ico", "x225 y1 h24 w24 gGlue", 24, 24) 
AddGraphicButton("Gotocursor", A_WorkingDir . "\gotocursor.ico", "x250 y1 h24 w24 gGotocursor", 24, 24) 
AddGraphicButton("Showlanes", A_WorkingDir . "\showlanes.ico", "x275 y1 h24 w24 gShowlanes", 24, 24)
AddGraphicButton("Overlap", A_WorkingDir . "\overlap.ico", "x300 y1 h24 w24 gOverlap", 24, 24)
AddGraphicButton("Tzoommax", A_WorkingDir . "\tzoommax.ico", "x325 y1 h24 w24 gTzoommax", 24, 24)
AddGraphicButton("Tzoommin", A_WorkingDir . "\tzoommin.ico", "x350 y1 h24 w24 gTzoommin", 24, 24)
AddGraphicButton("Auto", A_WorkingDir . "\auto.ico", "x375 y1 h24 w24 gAuto", 24, 24)
AddGraphicButton("Autolatch", A_WorkingDir . "\autolatch.ico", "x400 y1 h24 w24 gAutolatch", 24, 24)
AddGraphicButton("Autoread", A_WorkingDir . "\autoread.ico", "x425 y1 h24 w24 gAutoread", 24, 24)
AddGraphicButton("Autotouch", A_WorkingDir . "\autotouch.ico", "x450 y1 h24 w24 gAutotouch", 24, 24)
AddGraphicButton("Autowrite", A_WorkingDir . "\autowrite.ico", "x475 y1 h24 w24 gAutowrite", 24, 24)
AddGraphicButton("Panic", A_WorkingDir . "\panic.ico", "x500 y1 h24 w24 gPanic", 24, 24)
AddGraphicButton("Region", A_WorkingDir . "\region.ico", "x525 y1 h24 w24 gRegion", 24, 24)
AddGraphicButton("Screensets", A_WorkingDir . "\screensets.ico", "x550 y1 h24 w24 gScreensets", 24, 24)
AddGraphicButton("Autotrim", A_WorkingDir . "\autotrim.ico", "x575 y1 h24 w24 gAutotrim", 24, 24)
AddGraphicButton("Exit", A_WorkingDir . "\Exit.ico", "x600 y1 h24 w24 gExit", 24, 24)

 

; Show the window 
Gui, Show, x250 y-12 h25 w625, REAPER Macros


; Image rollover for SampleButton1
OnMessage(0x200,"MOUSEOVER") 
Return

buttoninfo: ; Tooltips
TT_1_Freeze=Freeze
TT_1_UnFreeze=Unfreeze
TT_1_Marker=Drop Marker
TT_1_Mute=Mute/UnMute
TT_1_NewTrack=Insert New Track
TT_1_ItemProps=Item Properties
TT_1_TimeSig=Insert/Edit `ntime signature
TT_1_Render=Open Render dialog
TT_1_Clean=Clean current directory
TT_1_Glue=Glue selected items
TT_1_Gotocursor=Jump to Cursor
TT_1_Showlanes=Take: Toggle Show Lanes
TT_1_Overlap=Toggle Show Overlapping items
TT_1_Tzoommax=Track Zoom Max
TT_1_Tzoommin=Track Zoom Min
TT_1_Autolatch=Automation Latch mode
TT_1_AutoRead=Automation Read mode
TT_1_Autotouch=Automation Touch mode
TT_1_Auto=Automation Trim/Read mode
TT_1_Autowrite=Automation Write mode
TT_1_Panic=Send midi off
TT_1_Region=Add Region
TT_1_Screensets=View Screensets
TT_1_Autotrim=Auto trim/split selected items
TT_1_Exit=Quit Script

Return 

;###############################################
;The bit that does all the work
MOUSEOVER()
{ 
If A_Gui<=0 ;check if mouse is not on any gui
{
   Tooltip ;clear before return
   Return
}
   {
   MouseGetPos, X,Y,,, ;get the mouse co-ordinates
   X:=X+20 ;move it over a bit
   _tword=%A_GuiControl% ;make A_GuiControl a modifyable variable
   StringReplace,_tword,_tword,%A_Space%,,all ;remove the spaces so it can find the tooltip
   StringReplace,_tword,_tword,-,,all ;remove -
   StringReplace,_tword,_tword,:,,all ;remove :
   StringReplace,_tword,_tword,\,,all ;remove \
   StringReplace,_tword,_tword,.,,all ;remove .
   StringReplace,_tword,_tword,`n,,all ;remove any line returns
   _tip:=TT_%A_Gui%_%_tword% ;get the tooltip to display
   Tooltip,%_tip%,%X%,%Y% ;display it
   }
}   
Return
;###############################################


;Macros and Shortcutsfor each button:

Freeze: 
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {ALTDOWN}{CTRLDOWN}f{ALTUP}{CTRLUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
return

UnFreeze:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {ALTDOWN}{CTRLDOWN}u{ALTUP}{CTRLUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Marker:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {SHIFTDOWN}m{SHIFTUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Mute:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {ALTDOWN}m{ALTUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

NewTrack:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {CTRLDOWN}t{CTRLUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return


ItemProps:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {F2}
}
else
{
  MsgBox, 48, , Reaper not found!
}
return

TimeSig:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {SHIFTDOWN}c{SHIFTUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return


Render:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {ALTDOWN}{CTRLDOWN}r{ALTUP}{CTRLUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return


Clean:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {ALTDOWN}c{ALTUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Glue:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {SHIFTDOWN}g{SHIFTUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Gotocursor:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, '
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Showlanes:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {CTRLDOWN}l{CTRLUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Overlap:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {SHIFTDOWN}o{SHIFTUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Tzoommax:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {ALTDOWN}z{ALTUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Tzoommin:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {SHIFTDOWN}z{SHIFTUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return


Autolatch:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, a
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

AutoRead:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {SHIFTDOWN}a{SHIFTUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Autotouch:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {ALTDOWN}a{ALTUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Auto:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {SHIFTDOWN}1{SHIFTUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Autowrite:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {CTRLDOWN}1{CTRLUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Panic:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {f3}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Region:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {SHIFTDOWN}r{SHIFTUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Screensets:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {CTRLDOWN}e{CTRLUP}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return

Autotrim:
IfWinExist,ahk_class REAPERwnd
{
  WinActivate
Send, {ALTDOWN}t{ALTUP}{ENTER}
}
else
{
  MsgBox, 48, , Reaper not found!
}
Return


Exit:
ExitApp 
Return




GuiClose: 
ExitApp 



; ******************************************************************* 
; AddGraphicButton.ahk
; ******************************************************************* 
; Version: 2.1 Updated: May 20, 2007 
; by corrupt 
; Code contributions by: lingoist 
; ******************************************************************* 
; VariableName = variable name for the button 
; ImgPath = Path to the image to be displayed 
; Options = AutoHotkey button options (g label, button size, etc...) 
; bHeight = Image height (default = 32) 
; bWidth = Image width (default = 32) 
; ******************************************************************* 
; note: calling the function again with the same variable name will
; modify the image on the button
; ******************************************************************* 
AddGraphicButton(VariableName, ImgPath, Options="", bHeight=24, bWidth=24) 
{ 
Global 
Local ImgType, ImgType1, LR_LOADFROMFILE, NULL, BM_SETIMAGE 
; BS_BITMAP := 128, IMAGE_BITMAP := 0, BS_ICON := 64, IMAGE_ICON := 1 
LR_LOADFROMFILE := 16 
BM_SETIMAGE := 247 
NULL= 
SplitPath, ImgPath,,, ImgType1 
ImgTYpe := (ImgType1 = "bmp") ? 128 : 64
If (%VariableName%_img != "")
  DllCall("DeleteObject", "UInt", %VariableName%_img)
Else
  Gui, Add, Button,  v%VariableName% hwnd%VariableName%_hwnd +%ImgTYpe% %Options% 
ImgType := (ImgType1 = "bmp") ? 0 : 1 
%VariableName%_img := DllCall("LoadImage", "UInt", NULL, "Str", ImgPath, "UInt", ImgType, "Int", bWidth, "Int", bHeight, "UInt", LR_LOADFROMFILE, "UInt") 
DllCall("SendMessage", "UInt", %VariableName%_hwnd, "UInt", BM_SETIMAGE, "UInt", ImgType,  "UInt", %VariableName%_img) 
Return, %VariableName%_img ; Return the handle to the image 
} 


